#
# spec file for package cherokee (Version 0.99.19)
#
# Copyright (c) 2009 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           cherokee
Version:        1.0.12
Release:        5.1
#
%define        makeinstall make install DESTDIR="%{buildroot}"
%define        pkg_home /var/lib/%{name}
%define        pkg_name %{name}
%define        _bindir %{_sbindir}
#
Group:          Productivity/Networking/Web/Servers
License:        GPL
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  bison flex openssl-devel pam-devel pcre-devel openldap2-devel mysql-devel
BuildRequires:  gnutls-devel libopencdk libgcrypt libgpg-error zlib-devel lzo-devel
%if 0%{?suse_version} > 0910
BuildRequires:  GeoIP-devel
BuildRequires:  php5-fastcgi
%else
BuildRequires:  php4-fastcgi
%endif
PreReq:         %insserv_prereq %fillup_prereq /usr/sbin/groupadd /usr/sbin/useradd
# Makes Error on Factory
Requires:       libcherokee-base0, libcherokee-client0, libcherokee-server0
Requires:       spawn-fcgi, rrdtool, php5-fastcgi
#
Url:            http://www.cherokee-project.com/
Source0:        %{version}/%{name}-%{version}.tar.gz
Patch0:         cherokee-main_admin_rtn-1.0.10.diff

%if 0%{?suse_version}
Source1:        cherokee.init
%else
Source1:        cherokee.fedora.init
%endif
Source2:        cherokee.conf
#
Summary:        Flexible and Fast Webserver
%description
Cherokee is a very fast, flexible and easy to configure Web Server. It supports
the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
encrypted connections, Virtual hosts, Authentication, on the fly encoding,
Apache compatible log files, and much more.

This package contains the server and essential handlers.


Authors:
--------
    Alvaro Lopez Ortega <alvaro@alobbs.com>

%package     -n libcherokee-base0
Group:          Productivity/Networking/Web/Servers
#
Provides:       libcherokee-base = %{version}-%{release}
Obsoletes:      libcherokee-base < %{version}
#
Summary:        Base library of cherokee
%description -n libcherokee-base0
Cherokee is a very fast, flexible and easy to configure Web Server. It supports
the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
encrypted connections, Virtual hosts, Authentication, on the fly encoding,
Apache compatible log files, and much more.

This package holds the runtime library for libcherokee-base.


Authors:
--------
    Alvaro Lopez Ortega <alvaro@alobbs.com>


%post   -n libcherokee-base0   -p /sbin/ldconfig
%postun -n libcherokee-base0   -p /sbin/ldconfig

%package     -n libcherokee-client0
Group:          Productivity/Networking/Web/Servers
#
Requires:       libcherokee-base0
#
Provides:       libcherokee-client = %{version}-%{release}
Obsoletes:      libcherokee-client < %{version}
#
Summary:        Client library of cherokee
%description -n libcherokee-client0
Cherokee is a very fast, flexible and easy to configure Web Server. It supports
the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
encrypted connections, Virtual hosts, Authentication, on the fly encoding,
Apache compatible log files, and much more.

This package holds the runtime library for libcherokee-client.


Authors:
--------
    Alvaro Lopez Ortega <alvaro@alobbs.com>


%post   -n libcherokee-client0 -p /sbin/ldconfig
%postun -n libcherokee-client0 -p /sbin/ldconfig

# %package     -n libcherokee-config0
# Group:          Productivity/Networking/Web/Servers
#
# Requires:       libcherokee-base0, libcherokee-client0, libcherokee-server0
# Provides:       libcherokee-config = %{version}-%{release}
# Obsoletes:      libcherokee-config < %{version}
#
# Summary:        Config library of cherokee
# %description -n libcherokee-config0
# Cherokee is a very fast, flexible and easy to configure Web Server. It supports
# the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
# encrypted connections, Virtual hosts, Authentication, on the fly encoding,
# Apache compatible log files, and much more.
# 
# This package holds the runtime library for libcherokee-config.
#
#
# Authors:
# --------
#    Alvaro Lopez Ortega <alvaro@alobbs.com>
# %post   -n libcherokee-config0 -p /sbin/ldconfig
# %postun -n libcherokee-config0 -p /sbin/ldconfig

%package     -n libcherokee-server0
Group:          Productivity/Networking/Web/Servers

Requires:       libcherokee-base0

Provides:       libcherokee-server = %{version}-%{release}
Obsoletes:      libcherokee-server < %{version}

Summary:        Server library of cherokee
%description -n libcherokee-server0
Cherokee is a very fast, flexible and easy to configure Web Server. It supports
the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
encrypted connections, Virtual hosts, Authentication, on the fly encoding,
Apache compatible log files, and much more.

This package holds the runtime library for libcherokee-server.


Authors:
--------
   Alvaro Lopez Ortega <alvaro@alobbs.com>

%post   -n libcherokee-server0 -p /sbin/ldconfig
%postun -n libcherokee-server0 -p /sbin/ldconfig

%package devel
Group:          Development/Libraries/C and C++
#
Requires:       %{name} = %{version}
Requires:       libcherokee-base0, libcherokee-client0, libcherokee-server0
#
Summary:        Development files of cherokee
%description devel
Cherokee is a very fast, flexible and easy to configure Web Server. It supports
the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
encrypted connections, Virtual hosts, Authentication, on the fly encoding,
Apache compatible log files, and much more.

This package holds the development files for cherokee.


Authors:
--------
    Alvaro Lopez Ortega <alvaro@alobbs.com>

%package cget
Group:          Productivity/Networking/Web/Servers
#
Requires:       libcherokee-base0, libcherokee-client0
#
Summary:        Simple download utility based on the cherokee client library
%description cget
CGet is a simple download utility based on the cherokee client library.


Authors:
--------
    Alvaro Lopez Ortega <alvaro@alobbs.com>


%package example-pages
Group:          Productivity/Networking/Web/Servers
#
Requires:       %{name} = %{version}
#
Summary:        Example pages for cherokee
%description example-pages
Cherokee is a very fast, flexible and easy to configure Web Server. It supports
the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
encrypted connections, Virtual hosts, Authentication, on the fly encoding,
Apache compatible log files, and much more.

Example pages for cherokee


Authors:
--------
    Alvaro Lopez Ortega <alvaro@alobbs.com>


%package docs
Group:          Productivity/Networking/Web/Servers
#
Requires:       %{name}
#
Summary:        Documentation for cherokee
%description docs
Cherokee is a very fast, flexible and easy to configure Web Server. It supports
the widespread technologies nowadays: FastCGI, SCGI, PHP, CGI, TLS and SSL
encrypted connections, Virtual hosts, Authentication, on the fly encoding,
Apache compatible log files, and much more.

Documentation for cherokee.


Authors:
--------
    Alvaro Lopez Ortega <alvaro@alobbs.com>


%prep
%setup
%patch0 -p1

%build
%if 0%{?suse_version} > 1000
export CFLAGS="%{optflags} -fstack-protector"
%endif
%if 0%{?fedora_version} > 4
export CFLAGS="%{optflags} -fstack-protector"
%endif
%if 0%{?mandriva_version} > 2006
export CFLAGS="%{optflags} -fstack-protector"
%endif
export CFLAGS="$CFLAGS -DLDAP_DEPRECATED -fno-strict-aliasing"
%configure \
    --with-wwwroot=/srv/www/htdocs/ \
    --docdir=%{_docdir}/%{name}/ \
    --enable-tls=openssl --enable-pthreads --enable-trace --disable-static \
    --enable-os-string="openSUSE Build Service"
%{__make}

%install
%makeinstall docdir=%{_docdir}/%{name}/
%{__install} -m 0644 AUTHORS ChangeLog COPYING README \
    %{buildroot}%{_docdir}/%{name}
%{__install} -D -m 0644 pam.d_cherokee %{buildroot}%{_sysconfdir}/pam.d/%{name}
%{__install} -D -m 0755 %{S:1}   %{buildroot}/etc/init.d/%{name}
%if 0%{?suse_version}
%{__ln_s} -f /etc/init.d/%{name} %{buildroot}%{_sbindir}/rc%{name}
%endif
%{__install} -d %{buildroot}/var/{log,lib}/%{name}/
#
%{__install} -D -m 0644 %{S:2} %{buildroot}%{_sysconfdir}/%{name}/cherokee.conf
#
#{__mv} %{buildroot}%{_bindir}/{,cherokee_}spawn-fcgi
#{__mv} %{buildroot}%{_mandir}/man1/{,cherokee_}spawn-fcgi.1
#
%{__rm} -rv %{buildroot}%{_libdir}/*.la \
            %{buildroot}%{_libdir}/%{name}/*.la

%find_lang %{name}

%clean
%{__rm} -rf %{buildroot}

%pre
/usr/sbin/groupadd -r %{name} &>/dev/null ||:
/usr/sbin/useradd  -g %{name} -s /bin/false -r -c "%{name} web server" -d %{pkg_home} %{name} &>/dev/null ||:

%post
%fillup_and_insserv %{pkg_name}

%preun
%stop_on_removal %{pkg_name}

%postun
%restart_on_update %{pkg_name}
%{insserv_cleanup}


%files -f %{name}.lang
%defattr(-,root,root,-)
%config(noreplace) /etc/init.d/%{name}
%if 0%{?suse_version}
%{_sbindir}/rc%{name}
%endif
%{_bindir}/cherokee-panic
#%{_bindir}/cherokee_logrotate
%{_bindir}/cherokee-tweak
#{_bindir}/cherokee_spawn-fcgi
%{_sbindir}/cherokee-worker
%{_sbindir}/cherokee
%{_sbindir}/cherokee-admin
%{_sbindir}/CTK-run
%{_libdir}/%{name}
%{_datadir}/%{name}
%{_mandir}/man1/cherokee*.1*
%config(noreplace) %{_sysconfdir}/pam.d/%{name}
%config(noreplace) %{_sysconfdir}/%{name}
# %dir %attr(750,root,%{name}) %{_sysconfdir}/%{name}
# %dir %attr(750,root,%{name}) %{_sysconfdir}/%{name}/mods-available
# %dir %attr(750,root,%{name}) %{_sysconfdir}/%{name}/mods-enabled
# %dir %attr(750,root,%{name}) %{_sysconfdir}/%{name}/sites-available
# %dir %attr(750,root,%{name}) %{_sysconfdir}/%{name}/sites-enabled
# %dir %attr(750,root,%{name}) %{_sysconfdir}/%{name}/ssl
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/advanced.conf
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/cherokee.conf
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/icons.conf
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/mime.compression.types
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/mime.types
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/mods-available/admin
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/mods-available/ssl
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/sites-available/default
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/%{name}/sites-available/example.com
# %config(noreplace) %attr(640,root,%{name}) %{_sysconfdir}/cherokee/sites-enabled/default
# logs are written as root. no need to give perms to the cherokee user.
%dir %attr(-,wwwrun,www) /var/log/%{name}/
%dir %attr(-,wwwrun,www) /var/lib/%{name}/
%dir %{_docdir}/%{name}
#{_docdir}/%{name}/AUTHORS
#{_docdir}/%{name}/ChangeLog
#{_docdir}/%{name}/COPYING
#{_docdir}/%{name}/README
#{_docdir}/%{name}/TODO
%if 0%{?suse_version} < 1140
%dir %{_datadir}/locale/sv_SE
%dir %{_datadir}/locale/sv_SE/LC_MESSAGES
%endif

%files docs
%defattr(-,root,root,-)
%{_docdir}/%{name}/
#{_docdir}/%{name}/balancers/
#{_docdir}/%{name}/encoders/
#{_docdir}/%{name}/handlers/
#{_docdir}/%{name}/loggers/
#{_docdir}/%{name}/media/
#{_docdir}/%{name}/validators/

%files cget
%defattr(-,root,root,-)
%{_bindir}/cget
%{_mandir}/man1/cget.1*

%files -n libcherokee-base0
%defattr(-,root,root,-)
%{_libdir}/lib%{name}-base.so.*

%files -n libcherokee-client0
%defattr(-,root,root,-)
%{_libdir}/lib%{name}-client.so.*

%files -n libcherokee-server0
%defattr(-,root,root,-)
%{_libdir}/lib%{name}-server.so.*

# %files -n libcherokee-config0
# %defattr(-,root,root,-)
# %{_libdir}/libcherokee-config.so.*

%files example-pages
%defattr(-,root,root,-)
/srv/www/htdocs/images/
/srv/www/htdocs/index.html

%files devel
%defattr(-,root,root,-)
%{_mandir}/man1/cherokee-config.1*
%{_bindir}/cherokee-config
%{_includedir}/%{name}
%{_libdir}/pkgconfig/%{name}.pc
%{_datadir}/aclocal/%{name}.m4
%{_libdir}/lib%{name}-*.so

%changelog
* Fri Apr 15 2011 mrueckert@suse.de
- only own those directories on < 11.4
* Wed Dec  8 2010 tuukka.pasanen@ilmi.fi
- update to 1.0.12
  An unfortunate, high-visibility regression was introduced in
  Cherokee 1.0.12 that could stop the server from loading if the
  configuration file forbade the use of certain encoders. Please
  skip Cherokee 1.0.11 and upgrade to 1.0.12 directly to avoid this
  high-impact issue
- additional changes from 1.0.11
  This is mainly a bugfix release. Most of the fixes are related to
  memory management issues on Mac OS X and FreeBSD. A few minor
  issues have also been fixed in the wizards: the PHP wizard works
  on CentOS 5 now, and the Moodle wizard is distributed again. The
  Quality Assurance bench has been extended, so it can be run under
  Valgrind on Mac OS X. A few usability issues have been addressed
  in the configuration and monitoring GUI
- additional changes from 1.0.9
  This release ships a huge amount of new features and
  improvements. Caching policies can be defined on a per-rule
  basis. Custom headers can also be defined on each individual
  behavior rule. The redirection error handler accepts a 'default'
  option now. Complex virtual host matching rules are supported, so
  the classic "one IP per virtual server" SSL/TLS workaround can be
  now used in Cherokee. Also, the reverse proxy can now handler SVN
  (WebDAV) connections now. A new option to disable SSLv2 made it
  to the administration interface, etc. Upgrading is strongly
  encouraged
* Sun Aug 16 2009 sharms@ubuntu.com
- update to 1.0.8
  - FIX: SSL/TLS works with Firefox again
  - FIX: Better SSL/TLS connection close
  - NEW: Enhanced 'Header' rule match
  - FIX: Range requests work better now
  - FIX: Hot-linking wizard w/o Referer
  - FIX: Hot-linking wizard usability
  - FIX: Minor CSS fix in the default dirlist theme
  - DOC: Misc improvements
* Wed Jun 24 2009 mrueckert@suse.de
- update to 0.99.19
* Thu Feb 26 2009 mrueckert@suse.de
- update to 0.99.0
* Wed Feb  4 2009 mrueckert@suse.de
- fix build on sles9
* Tue Feb  3 2009 mrueckert@suse.de
- some fixes for 0.98.1
* Tue Feb  3 2009 mrueckert@suse.de
- update to 0.98.1
- added cherokee-0.98.1_buildwarnings.patch
* Mon Jul 30 2007 mrueckert@suse.de
- added a stupid hack as upstream did not bump the soname but
  running 0.5.5 with the 0.6.0-snapshot libs segfaults.
* Mon Jul 30 2007 mrueckert@suse.de
- added bison and flex to the build requires
* Thu Dec 14 2006 mrueckert@suse.de
- refreshed cherokee-0.5.4_default_config.patch. new name
  cherokee-0.5.6_default_config.patch
* Thu Dec 14 2006 mrueckert@suse.de
- update to version 0.5.6
- use the fedora.init for non suse distros
* Fri Sep 15 2006 mrueckert@suse.de
- build with -fstack-protector on suse newer than 10.0
* Thu Sep 14 2006 mrueckert@suse.de
- Initial package of version 0.5.5
